global recv
global send

-- This demo worked fine when using the "Virtual Serial Port Driver"
-- (http://www.eltima.com/products/vspdxp/) with the virtual port pair
-- COM3 and COM4.

----------------------------------------
--
----------------------------------------
on startMovie

  -- defaults if not specified:
  --   baud = 9600
  --   byteSize = 8
  --   parity = 2
  --   stopBits = 0
  --   dtrControl = 1
  --   rtsControl = 1

  baud = 19200
  byteSize = 8
  parity = 2
  stopBits = 0
  dtrControl = 0
  rtsControl = 0


  ----------------------------------------
  -- RECEIVER (COM4)
  ----------------------------------------
  recv = Xtra("Serial").new()
  ok = recv.open(4, baud, byteSize, parity, stopBits, dtrControl, rtsControl)

  -- set callback for data received on COM4
  recv.setDataCallback(#slotData)

  ----------------------------------------
  -- SENDER (COM3)
  ----------------------------------------
  send = Xtra("Serial").new()
  ok = send.open(3, baud, byteSize, parity, stopBits, dtrControl, rtsControl)

  -- send byte 23
  res = send.sendData(bytearray(1, 23))

  -- send string "Hello"
  res = send.sendData(bytearray("Hello"))
  --put res

  put "DONE."
end

----------------------------------------
--
----------------------------------------
on stopMovie
  -- close ports
  recv.close()
  send.close()
end

----------------------------------------
-- @callback
----------------------------------------
on slotData (data)
  put "slotData:" && data

  --  if ilk(data)=#bytearray then
  --    put "data:" && data.readRawString(data.length)
  --  end if

end